<%-- $Id: view_event.jsp 6306 2013-08-13 13:15:33Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Plate"
	import="net.sf.basedb.core.BioMaterial"
	import="net.sf.basedb.core.BioMaterialEvent"
	import="net.sf.basedb.core.BioMaterialEventSource"
	import="net.sf.basedb.core.BioPlateEventParticipant"
	import="net.sf.basedb.core.BioPlateEvent"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.MeasuredBioMaterial"
	import="net.sf.basedb.core.PhysicalBioAssay"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.SpecialQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.ResultList"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.util.formatter.NumberFormatter"
	import="net.sf.basedb.util.formatter.PrefixSuffixFormatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.Set"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.BIOMATERIALEVENT;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final Item bioMaterialType = Item.valueOf(request.getParameter("biomaterial_type"));
final String tab = Values.getStringOrNull(request.getParameter("tab"));
final int bioMaterialId = Values.getInt(request.getParameter("biomaterial_id"));
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	Formatter<Number> numberFormatter = FormatterFactory.getNumberFormatter(sc);
	Formatter<Number> quantityFormatter = new PrefixSuffixFormatter(null, false, numberFormatter, " µg", false);

	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	BioMaterialEvent event = BioMaterialEvent.getById(dc, itemId);
	MeasuredBioMaterial bioMaterial = (MeasuredBioMaterial)bioMaterialType.getById(dc, bioMaterialId);
	BioMaterialEvent.Type eventType = event.getEventType();
	boolean isPlateEvent = event.isPlateEvent();
	
	BioPlateEventParticipant participant = null;
	BioPlateEvent plateEvent = null;
	BioPlate plate = null;
	if (isPlateEvent)
	{
		try
		{
			participant = event.getBioPlateEventParticipant();
			plateEvent = participant.getEvent();
			plate = participant.getBioPlate();
		}
		catch (RuntimeException ex)
		{}
	}
	
	String viewPage = null;
	String listName = null;
	if (bioMaterialType == Item.SAMPLE)
	{
		listName = "Samples";
		viewPage = "../samples/index.jsp";
	}
	else if (bioMaterialType == Item.EXTRACT)
	{
		listName = "Extracts";
		viewPage = "../extracts/index.jsp";
	}

	final boolean writePermission = event.hasPermission(Permission.WRITE) && eventType == BioMaterialEvent.Type.OTHER;
	final boolean deletePermission = event.hasPermission(Permission.DELETE);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, event);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>" id="view-page">
	<base:head scripts="table.js,tabcontrol-2.js,~events.js" styles="toolbar.css,table.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<p:path><p:pathelement 
			title="<%=listName%>" href="<%=viewPage+"?ID="+ID%>" /><p:pathelement 
			title="<%=HTML.encodeTags(bioMaterial.getName())%>" 
				href="<%="index.jsp?ID="+ID+"&amp;biomaterial_id="+bioMaterialId+"&amp;biomaterial_type="+bioMaterialType.name()%>" 
			/><p:pathelement title="Event" /></p:path>
		<div id="page-data" data-item-id="<%=itemId%>"></div>
		
		<t:tabcontrol id="main" 
			subclass="content mastertabcontrol"
			active="<%=tab%>">
		<t:tab id="properties" title="Properties">
			<div>
			<table class="fullform bottomborder">
			<tr>
				<th class="itemstatus"></th>
				<td style="padding: 0px;">
					<tbl:toolbar subclass="bottomborder">
						<tbl:button 
							id="btnEdit"
							disabled="<%=!writePermission%>" 
							data-extra-url="<%="&biomaterial_type="+bioMaterialType.name()+"&biomaterial_id="+bioMaterialId%>"
							image="edit.png" 
							title="Edit&hellip;" 
							tooltip="<%=writePermission ? "Edit this event" : "You do not have permission to edit this event"%>" 
						/>
						<tbl:button 
							id="btnDelete"
							data-confirm="1"
							data-extra-url="<%="&biomaterial_type="+bioMaterialType.name()+"&biomaterial_id="+bioMaterialId%>"
							disabled="<%=!deletePermission%>" 
							image="delete.png" 
							title="Delete"
							tooltip="<%=deletePermission ? "Delete this event" : "You do not have permission to event this event"%>" 
						/>
						<tbl:button 
							id="btnImport"
							image="import.png" 
							data-plugin-type="IMPORT"  
							title="Import&hellip;" 
							tooltip="Import data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
						/>
						<tbl:button 
							id="btnExport"
							image="export.png"
							data-plugin-type="EXPORT" 
							title="Export&hellip;" 
							tooltip="Export data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
						/>
						<tbl:button 
							id="btnRunPlugin"
							image="runplugin.png"  
							data-plugin-type="OTHER" 
							title="Run plugin&hellip;" 
							tooltip="Run a plugin" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
						/>
						<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
							wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
					</tbl:toolbar>
				</td>
			</tr>
			<%
			if (isPlateEvent)
			{
				%>
				<tr>
					<th>Releated plate event</th>
					<td><%=Base.getLinkedName(ID, plateEvent, plateEvent == null, true) %></td>
				</tr>
				<tr>
					<th class="subprompt">- bioplate</th>
					<td><%=Base.getLinkedName(ID, plate, plate == null, true)%>
					<%
					if (participant != null)
					{
						%>
						(<%=HTML.encodeTags(participant.getRole())%>)
						<%
					}
					%>
					</td>
				</tr>
				<tr>
					<th class="subprompt">- event type</th>
					<td><%
						if (plateEvent != null)
						{
							%>
							<base:propertyvalue item="<%=plateEvent%>" property="eventType" />
							<%
						}
						%>
					</td>
				</tr>
				<%
			}
			%>
			<tr>
				<th>Event date</th>
				<td><%=dateFormatter.format(event.getEventDate())%></td>
			</tr>
			<tr>
				<th>Registration date</th>
				<td><%=dateFormatter.format(event.getEntryDate())%></td>
			</tr>
			<tr>
				<th>Used quantity</th>
				<td><%=quantityFormatter.format(event.getUsedQuantity(bioMaterial))%></td>
			</tr>
			<tr>
				<th>Event type</th>
				<td><%=eventType%></td>
			</tr>
			<%
			if (eventType != BioMaterialEvent.Type.OTHER)
			{
				if (eventType == BioMaterialEvent.Type.CREATION)
				{					
					%>
					<tr>
						<th>Product</th>
						<td><base:propertyvalue item="<%=event%>" property="bioMaterial"/></td>
					</tr>
					<%
				}
				else if (eventType == BioMaterialEvent.Type.BIOASSAY)
				{					
					%>
					<tr>
						<th>Physical bioassay</th>
						<td><base:propertyvalue item="<%=event%>" property="physicalBioAssay"/></td>
					</tr>
					<%
				}
				SpecialQuery<BioMaterialEventSource> sourcesQuery = event.getEventSources();
				sourcesQuery.order(Orders.asc(Hql.property("bioMaterial.name")));
				ResultList<BioMaterialEventSource> sources = sourcesQuery.list(dc);
				%>
				<tr class="big">
					<th>Sources</th>
					<td>
					<%
					for (BioMaterialEventSource evtSrc : sources)
					{
						BioMaterial source = null;
						Item sourceType = null;
						try
						{
							source = evtSrc.getBioMaterial();
							sourceType = source.getType();
						}
						catch (PermissionDeniedException ex)
						{}
						%>
						<%=Base.getLinkedName(ID, source, source == null, true)%>
						<%=sourceType != null ? "(" + sourceType + ")" : "" %>
						<%=quantityFormatter.format(evtSrc.getUsedQuantity())%>
						<br>
						<%
					}
					%>
					</td>
				</tr>
				<%
			}
			%>
			<tr>
				<th>Protocol</th>
				<td><base:propertyvalue item="<%=event%>" property="protocol"/></td>
			</tr>
			<tr>
				<th>User</th>
				<td><base:propertyvalue item="<%=event%>" property="user"/></td>
			</tr>
			<tr>
				<th>Permissions</th>
				<td><%=PermissionUtil.getFullPermissionNames(event)%></td>
			</tr>
			<tr>
				<th>Comment</th>
				<td><%=HTML.niceFormat(event.getComment())%></td>
			</tr>
			</table>
			</div>
			
			<jsp:include page="../../common/anytoany/list_anytoany.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Other items related to this event" />
			</jsp:include>

			</t:tab>
			</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
