<%-- $Id: edit_list.jsp 6390 2014-01-21 08:04:27Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2008 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.10
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.BioMaterialList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final Item itemType = Item.BIOMATERIALLIST;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	BioMaterialList list = null;
	Item memberType = null;
	boolean addBioMaterials = false;
	boolean mergeLists = false;
	int numSelectedLists = cc.getSelected().size();
	String formId = request.getParameter("formId");
	String fromContext = Values.getStringOrNull(request.getParameter("fromContext"));
	String subContext = request.getParameter("subContext");

	if (itemId == 0)
	{
		title = "Create biomaterial list";
		cc.removeObject("item");
		addBioMaterials = Values.getBoolean(request.getParameter("addBioMaterials"));
		if (numSelectedLists > 0)
		{
			for (int selectedId : cc.getSelected())
			{
				BioMaterialList selectedList = BioMaterialList.getById(dc, selectedId);
				if (memberType == null)
				{
					memberType = selectedList.getMemberType();
				}
				else if (memberType != selectedList.getMemberType())
				{
					numSelectedLists = 0;
					memberType = null;
					break;
				}
			}
		}
		if (memberType == null)
		{
			memberType = fromContext != null ? Item.valueOf(fromContext) : Item.fromValue(Values.getInt(cc.getPropertyValue("memberType")));
		}
		mergeLists = numSelectedLists > 0;
	}
	else
	{
		list = BioMaterialList.getById(dc, itemId);
		list.checkPermission(Permission.WRITE);
		memberType = list.getMemberType();
		cc.setObject("item", list);
		title = "Edit biomaterial list -- " + HTML.encodeTags(list.getName());
	}
	
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), list);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>" id="edit-page">
	<base:head scripts="tabcontrol-2.js,~lists.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<h1><%=title%> <base:help tabcontrol="settings"/></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="list">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="fromContext" value="<%=fromContext%>">
		<%
		if (subContext != null)
		{
			%>
			<input type="hidden" name="subContext" value="<%=subContext%>">
			<%
		}
		%>
		<t:tabcontrol id="settings"
			subclass="content dialogtabcontrol"
			position="bottom"  remember="<%=list != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Biomaterial list" helpid="biomateriallist.edit">
			<table class="fullform input100">
			<tr>
				<th>Name</th>
				<td><input class="text required auto-init" data-auto-init="<%=list == null ? "focus-select" : "focus" %>" 
					type="text" name="name" 
					value="<%=HTML.encodeTags(list == null ? Values.getString(cc.getPropertyValue("name"), "New list") : list.getName())%>" 
					maxlength="<%=BioMaterialList.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Member type</th>
				<td>
					<select name="memberType" <%=mergeLists || list != null ? "disabled" : "" %>>
						<option value="BIOSOURCE" <%=memberType == Item.BIOSOURCE ? "selected" : ""%>>Biosource
						<option value="SAMPLE" <%=memberType == Item.SAMPLE ? "selected" : ""%>>Sample
						<option value="EXTRACT" <%=memberType == Item.EXTRACT ? "selected" : ""%>>Extract
					</select>
				</td>
				<td></td>
			</tr>
			<%
			if (addBioMaterials)
			{
				%>
				<tr>
					<th style="height: 5em;">Source biomaterials</th>
					<td>
						<input type="radio" name="source" id="sourceSelected" value="selected"
							data-parent-form="<%=formId%>"
							><label for="sourceSelected" id="lblSelected">Selected items</label><br>
						<input type="radio" name="source" id="sourcePage" value="page"
							><label for="sourcePage">Current page</label><br>
						<input type="radio" name="source" id="sourceAll" value="all" checked
							><label for="sourceAll">All pages</label><br>
					</td>
					<td></td>
				</tr>
				<tr>
					<th>Include pooled</th>
					<td>
						<input type="checkbox" name="pooled" id="pooled" value="1"
							><label for="pooled">Include pooled children/parents in the list</label><br>
					</td>
					<td></td>
				</tr>
				<%
			}
			else if (mergeLists)
			{
				%>
				<tr>
					<th style="height: 6em;">Add members?</th>
					<td>
						<input type="radio" name="create" id="createEmpty" value=""
							><label for="createEmpty" title="The new list will be empty">No</label><br>
						<input type="radio" name="create" id="createUnion" value="union" checked
							><label for="createUnion" title="The new list contains all items from the selected lists">Union of selected lists</label> <base:icon image="set_operations/union_small.png" /><br>
						<input type="radio" name="create" id="createIntersection" value="intersection"
							><label for="createIntersection" title="The new list contains only items that are present in ALL selected lists">Intersection of selected lists</label> <base:icon image="set_operations/intersection_small.png" /><br>
						<input type="radio" name="create" id="createCount" value="count"
							><label for="createCount" title="The new list contains only items that are present in some of selected lists">Present in at least</label>
							<input type="text" class="text" name="minCount" id="minCount" style="width: 3em;" maxlength="2"
								value="1">
							of the selected lists (1-<%=numSelectedLists%>).
							<br>
					</td>
					<td></td>
				</tr>
				<%
			}
			%>
			<tr>
				<th>External ID</th>
				<td><input class="text" type="text" name="external_id" 
					value="<%=HTML.encodeTags(list == null ? Values.getString(cc.getPropertyValue("externalId"), "") : list.getExternalId())%>" 
					maxlength="<%=BioMaterialList.MAX_EXTERNAL_ID_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea class="text" rows="6" name="description" id="description"
						><%=HTML.encodeTags(list == null ? cc.getPropertyValue("description") : list.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="description" title="Description" />
				</td>
			</tr>
			</table>
		</t:tab>
		<t:tab id="annotations" title="Annotations" helpid="annotations.edit">
			<jsp:include page="../../common/annotations/annotate_frameset.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
		</t:tab>
		</t:tabcontrol>
		</form>

		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
