<%-- $Id: index.jsp 6278 2013-05-24 10:41:55Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2008 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.10
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.BioMaterialList"
	import="net.sf.basedb.core.BioMaterial"
	import="net.sf.basedb.core.Sample"
	import="net.sf.basedb.core.Extract"
	import="net.sf.basedb.core.PhysicalBioAssay"
	import="net.sf.basedb.core.BioPlateEventType"
	import="net.sf.basedb.core.OwnedItem"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.ShareableUtil"
	import="net.sf.basedb.util.RemovableUtil"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.formatter.NameableFormatter"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.util.formatter.ItemTypeFormatter"
	import="net.sf.basedb.clients.web.plugins.BioMaterialEventSourceFormatter"
	import="net.sf.basedb.clients.web.plugins.ItemQueryLoader"
	import="net.sf.basedb.clients.web.plugins.ParentBioMaterialEventSourceLoader"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnExportRenderer"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnUtil"
	import="java.util.Arrays"
	import="java.util.Collections"
	import="java.util.Set"
	import="java.util.HashSet"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%!
	private static final ItemContext defaultContext = Base.createDefaultContext("name", "name,itemSubtype,description");

	private static void registerExportUtils(ItemContext cc)
	{
		Item memberType = cc.getItemType();
		if (memberType == Item.BIOSOURCE)
		{
			// Register formatters
			cc.setObject("export.formatter.&children(name)", new NameableFormatter());
					
			// Register dataloaders
			String bioSourceParameter = "bioSource";
			final ItemQuery<Sample> sampleQuery = Sample.getQuery();
			sampleQuery.include(cc.getInclude());
			sampleQuery.restrict(Restrictions.eq(Hql.property("parent"), Expressions.parameter(bioSourceParameter)));
			sampleQuery.order(Orders.asc(Hql.property("name")));
			cc.setObject("export.dataloader.&children(name)", new ItemQueryLoader(sampleQuery, bioSourceParameter));
		}
		else if (memberType == Item.SAMPLE)
		{
			// Register formatters
			cc.setObject("export.formatter.bioWell.row", new WellCoordinateFormatter(true));
			cc.setObject("export.formatter.bioWell.column", new WellCoordinateFormatter(false));
			cc.setObject("export.formatter.&creationEvent.sources(bioMaterial.name)", new BioMaterialEventSourceFormatter());
			cc.setObject("export.formatter.&childCreationEvents(event.bioMaterial.name)", new NameableFormatter());
			cc.setObject("export.formatter.&children(name)", new NameableFormatter());
			cc.setObject("export.formatter.parentType", new ItemTypeFormatter());
			
			// Register dataloaders
			String sampleParameter = "sample";

			// Child extracts
			ItemQuery<Extract> extractQuery = Extract.getQuery();
			extractQuery.include(cc.getInclude());
			extractQuery.restrict(Restrictions.eq(Hql.property("parent"), Expressions.parameter(sampleParameter)));
			extractQuery.order(Orders.asc(Hql.property("name")));
			cc.setObject("export.dataloader.&children(name)", new ItemQueryLoader(extractQuery, sampleParameter));

			// Child samples
			ItemQuery<Sample> childSamplesQuery = Sample.getQuery();
			childSamplesQuery.join(Hql.innerJoin("creationEvent", "ce"));
			childSamplesQuery.join(Hql.innerJoin("ce", "sources", "src"));
			childSamplesQuery.restrict(Restrictions.eq(Hql.property("src", "bioMaterial"), Expressions.parameter(sampleParameter)));
			childSamplesQuery.order(Orders.asc(Hql.property("name")));
			childSamplesQuery.include(cc.getInclude());
			cc.setObject("export.dataloader.&childCreationEvents(event.bioMaterial.name)", new ItemQueryLoader(childSamplesQuery, sampleParameter));
			
			// Parent samples
			cc.setObject("export.dataloader.&creationEvent.sources(bioMaterial.name)", new ParentBioMaterialEventSourceLoader());
		}
		else if (memberType == Item.EXTRACT)
		{
			cc.setObject("export.formatter.bioWell.row", new WellCoordinateFormatter(true));
			cc.setObject("export.formatter.bioWell.column", new WellCoordinateFormatter(false));
			cc.setObject("export.formatter.&children(name)", new NameableFormatter());
			cc.setObject("export.formatter.&creationEvent.sources(bioMaterial.name)", new BioMaterialEventSourceFormatter());
			cc.setObject("export.formatter.&childCreationEvents(event.physicalBioAssay.name)", new NameableFormatter());
			cc.setObject("export.formatter.&childCreationEvents(event.bioMaterial.name)", new NameableFormatter());
			cc.setObject("export.formatter.parentType", new ItemTypeFormatter());
			
			String restrictionParameter = "extract";

			// Physical bioassays
			ItemQuery<PhysicalBioAssay> bioAssayQuery = PhysicalBioAssay.getQuery();
			bioAssayQuery.join(Hql.innerJoin("creationEvent", "ce"));
			bioAssayQuery.join(Hql.innerJoin("ce", "sources", "src"));
			bioAssayQuery.restrict(Restrictions.eq(Hql.property("src", "bioMaterial"), Expressions.parameter(restrictionParameter)));
			bioAssayQuery.order(Orders.asc(Hql.property("name")));
			bioAssayQuery.include(cc.getInclude());
			cc.setObject("export.dataloader.&childCreationEvents(event.physicalBioAssay.name)", new ItemQueryLoader(bioAssayQuery, restrictionParameter));

			// Child extracts
			ItemQuery<Extract> childExtractsQuery = Extract.getQuery();
			childExtractsQuery.join(Hql.innerJoin("creationEvent", "ce"));
			childExtractsQuery.join(Hql.innerJoin("ce", "sources", "src"));
			childExtractsQuery.restrict(Restrictions.eq(Hql.property("src", "bioMaterial"), Expressions.parameter(restrictionParameter)));
			childExtractsQuery.order(Orders.asc(Hql.property("name")));
			childExtractsQuery.include(cc.getInclude());
			cc.setObject("export.dataloader.&childCreationEvents(event.bioMaterial.name)", new ItemQueryLoader(childExtractsQuery, restrictionParameter));
			
			// Parent items
			cc.setObject("export.dataloader.&creationEvent.sources(bioMaterial.name)", new ParentBioMaterialEventSourceLoader());
		}
	}
%>
<%
final int bioMaterialListId = Values.getInt(request.getParameter("list_id"));
final String subContext = "listmembers."+bioMaterialListId;

final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
final String mode = request.getParameter("mode");
final String callback = request.getParameter("callback");
final String listPage = "list_members.jsp?ID="+ID
	+"&list_id="+bioMaterialListId
	+(mode == null ? "" : "&mode="+mode)
	+(callback == null ? "" : "&callback="+callback);

String forward = null;
String redirect = null;
String message = null;
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final BioMaterialList list = BioMaterialList.getById(dc, bioMaterialListId);
	final Item itemType = list.getMemberType();
	
	if (cmd == null || "List".equals(cmd))
	{
		// Display the list page without updatinging the current context
		Base.getAndSetCurrentContext(sc, itemType, subContext, (PageContext)null, defaultContext, true);
		redirect = listPage;
	}
	else if ("UpdateContext".equals(cmd))
	{
		// Display the list page after updating the current context from the request parameters
		Base.getAndSetCurrentContext(sc, itemType, subContext, pageContext, defaultContext);
		redirect = listPage;
	}
	else if ("LoadContext".equals(cmd))
	{
		// Display the list page after loading a saved context
		int contextId = Values.getInt(request.getParameter("context"));
		Base.loadContext(sc, contextId, defaultContext);
		redirect = listPage;
	}
	else if ("DeleteItems".equals(cmd))
	{
		// Delete all selected items on the list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subContext, pageContext, defaultContext);
		int numTotal = cc.getSelected().size();
		int numRemoved = RemovableUtil.setRemoved(dc, itemType, cc.getSelected(), true);
		dc.commit();
		if (numTotal != numRemoved)
		{
			message = (numRemoved == 0 ? "No" : "Only "+numRemoved+" of "+numTotal) + " items could be deleted, because you have no DELETE permission";
		}
		redirect = listPage;
	}
	else if ("RestoreItems".equals(cmd))
	{
		// Restore all selected items on the list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subContext, pageContext, defaultContext);
		int numTotal = cc.getSelected().size();
		int numRemoved = RemovableUtil.setRemoved(dc, itemType, cc.getSelected(), false);
		dc.commit();
		if (numTotal != numRemoved)
		{
			message = (numRemoved == 0 ? "No" : "Only "+numRemoved+" of "+numTotal) + " items could be restored, because you have no WRITE permission";
		}
		redirect = listPage;
	}
	else if ("ShareItem".equals(cmd))
	{
		// Display a popup window for sharing a single item
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subContext, pageContext, defaultContext);
		MultiPermissions permissions = ShareableUtil.getMultiPermissions(dc, itemType, Collections.singleton(cc.getId()));
		dc.close();
		cc.setObject("MultiPermissions", permissions);
		redirect = "../../../common/share/share.jsp?ID="+ID+"&item_type="+itemType.name()+"&subcontext="+subContext;
	}
	else if ("ShareItems".equals(cmd))
	{
		// Display a popup window for sharing all selected items on the list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subContext, pageContext, defaultContext);
		MultiPermissions permissions = ShareableUtil.getMultiPermissions(dc, itemType, cc.getSelected());
		dc.close();
		cc.setObject("MultiPermissions", permissions);
		redirect = "../../../common/share/share.jsp?ID="+ID+"&item_type="+itemType.name()+"&subcontext="+subContext;
	}
	else if ("SetOwnerOfItems".equals(cmd))
	{
		// Change owner of items selected on a list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subContext, pageContext, defaultContext);
		Set<OwnedItem> items = new HashSet<OwnedItem>();
		for (Integer id : cc.getSelected())
		{
			if (id != null) items.add((OwnedItem)itemType.getById(dc, id));
		}
		dc.close();
		cc.setObject("OwnedItems", items);
		redirect = "../../../common/ownership/ownership.jsp?ID="+ID+"&item_type="+itemType.name()+"&subcontext="+subContext;
	}
	else if ("ExportItems".equals(cmd))
	{
		// Run an export plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subContext, pageContext, defaultContext);
		registerExportUtils(cc);
		final ItemQuery<? extends BioMaterial> query = list.getMemberBioMaterials();
		dc = sc.newDbControl();
		cc.configureQuery(dc, query, true);
		cc.setQuery(query);
		JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.list(itemType), null);
		ExtensionsInvoker listInvoker = ListColumnUtil.useExtensions(jspContext);
		listInvoker.render(new ListColumnExportRenderer(cc));
		dc.close();
		redirect = "../../../common/export/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&subcontext="+subContext+"&title=Export+list+members";
	}
	else if ("ImportItems".equals(cmd))
	{
		// Run an import plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subContext, pageContext, defaultContext);
		final ItemQuery<? extends BioMaterial> query = list.getMemberBioMaterials();
		cc.configureQuery(dc, query, true);
		cc.setQuery(query);
		dc.close();
		redirect = "../../../common/import/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&subcontext="+subContext+"&title=Import+list+members";
	}
	else if ("RunListPlugin".equals(cmd))
	{
		// Run another plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subContext, pageContext, defaultContext);
		final ItemQuery<? extends BioMaterial> query = list.getMemberBioMaterials();
		cc.configureQuery(dc, query, true);
		cc.setQuery(query);
		dc.close();
		redirect = "../../../common/plugin/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&subcontext="+subContext+"&main_type=OTHER&title=Run+plugin";
	}
	else if ("AddMembers".equals(cmd))
	{
		ItemContext memberContext = sc.getCurrentContext(itemType);
		final ItemQuery<? extends BioMaterial> query = list.getAllBioMaterials();
		memberContext.configureQuery(dc, query, true);
		String which = request.getParameter("which");
		if ("selected".equals(which))
		{
			query.setFirstResult(0);
			query.setMaxResults(-1);
			Integer[] itemIds = Values.getInt(request.getParameter("items").split(","));
			query.restrict(
				Restrictions.in(
					Hql.property("id"),
					Expressions.parameter("_selected_")
				)
			);
			query.setParameter("_selected_", Arrays.asList(itemIds), Type.INT);			
		}
		else if ("all".equals(which))
		{
			query.setFirstResult(0);
			query.setMaxResults(-1);
		}
		ItemResultIterator<? extends BioMaterial> result = query.iterate(dc);
		int count = 0;
		while (result.hasNext())
		{
			if (list.add(result.next())) count++;
		}
		dc.commit();
		message = count + " biomaterial(s) added to list";
	}
	else if ("RemoveMembers".equals(cmd))
	{
		// Delete all selected items on the list page
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subContext, pageContext, defaultContext);
		for (int itemId : cc.getSelected())
		{
			list.remove((BioMaterial)itemType.getById(dc, itemId));
		}
		dc.commit();
		redirect = listPage;
	}
	else if ("PlaceOnPlate".equals(cmd))
	{
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subContext, pageContext, defaultContext);
		final ItemQuery<? extends BioMaterial> query = list.getMemberBioMaterials();
		cc.configureQuery(dc, query, true);
		cc.filterOnSelectedItems(query);
		sc.getCurrentContext(Item.BIOPLATEEVENT, BioPlateEventType.PLACE_ON_PLATE).setQuery(query);
		redirect = "../../wizards/place_on_plate.jsp?ID="+ID+"&itemType=" + itemType.name() + "&subcontext="+subContext;
		dc.close();
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
finally
{
	if (dc != null) dc.close();
}

if (forward != null)
{
	sc.setSessionSetting("alert-message", message);
	pageContext.forward(forward);
}
else if (redirect != null)
{
	sc.setSessionSetting("alert-message", message);
	response.sendRedirect(redirect);
}
else if (message == null)
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&wait=0");
}
else
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&message="+HTML.urlEncode(message));
}
%>

