/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2014 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/

var Wizards = function()
{
	var wizards = {};
	
	wizards.selectHardware = function()
	{
		var frm = document.forms['main'];
		
		var url = '&resetTemporary=1';
		if (frm.hardware_id.length > 1) 
		{
			var id = Math.abs(parseInt(frm.hardware_id[1].value));				
			url += '&item_id='+id;
		}
		var hardwareType = Data.int('page-data', 'hardware-type');
		if (hardwareType)
		{
			url += '&tmpfilter:INT:itemSubtype='+hardwareType;
		}
		Dialogs.selectItem('HARDWARE', 'hardware_id', 0, url);
	}
	
	
	wizards.setHardwareCallback = function(event)
	{
		var frm = document.forms['main'];
		var list = frm.hardware_id;
		if (list.length < 2 || list[1].value == '0')
		{
			Forms.addListOption(list, 1, new Option());
		}
		list[1].value = event.detail.id;
		list[1].text = event.detail.name;
		list.selectedIndex = 1;
	}

	
	wizards.selectProtocol = function()
	{
		var frm = document.forms['main'];
		var url = '&resetTemporary=1';
		if (frm.protocol_id.length > 1) 
		{
			var id = Math.abs(parseInt(frm.protocol_id[1].value));				
			url += '&item_id='+id;
		}
		var protocolType = Data.int('page-data', 'protocol-type');
		if (protocolType)
		{
			url += '&tmpfilter:INT:itemSubtype='+protocolType;
		}
		Dialogs.selectItem('PROTOCOL', 'protocol_id', 0, url);
	}
	
	wizards.setProtocolCallback = function(event)
	{
		var frm = document.forms['main'];
		var list = frm.protocol_id;
		if (list.length < 2 || list[1].value == '0')
		{
			Forms.addListOption(list, 1, new Option());
		}
		list[1].value = event.detail.id;
		list[1].text = event.detail.name;
		list.selectedIndex = 1;
	}


	return wizards;
}();

