/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2012 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/

var Owner = function()
{
	var owner = {};
	
	/**
		Initialize the page.
	*/
	owner.initPage = function()
	{
		// Buttons
		Buttons.addClickHandler('close', App.closeWindow);
		Buttons.addClickHandler('btnSave', owner.save);
		
		Buttons.addClickHandler('owner_id.select', owner.selectUser);
		Events.addEventHandler('owner_id', 'base-selected', owner.setOwnerCallback);
	}
	
	/**
		Open the 'select user' dialog.
	*/
	owner.selectUser = function()
	{
		var frm = document.forms['ownership'];
		var url = '';
		if (frm.owner_id.value > 0) 
		{
			var id = Math.abs(parseInt(frm.owner_id.value));				
			url = '&item_id='+id;
		}
		
		Dialogs.selectItem('USER', 'owner_id', 0, url);
	}

	owner.setOwnerCallback = function(event)
	{
		var id = event.detail.id;
		var name = event.detail.name;
		var frm = document.forms['ownership'];
		var list = frm.owner_id;
		if (list.length < 2 || list[1].value == '0')
		{
			Forms.addListOption(list, 1, new Option());
		}
		list[1].value = id;
		list[1].text = name;
		list.selectedIndex = 1;
	}
	
	/**
		Save settings and close the dialog.
	*/
	owner.save = function()
	{
		var frm = document.forms['ownership'];
		frm.submit();
	}
	
	return owner;
}();

Doc.onLoad(Owner.initPage);