<%-- $Id: select_color.jsp 6187 2012-10-29 14:49:34Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	A window for selecting a color interactively from a color chart.

	@param title The title of the input field on the parent form
	@param form The name of the form where the input field is located
	@param input The name of the input field containing the current color value
	@param callback A javascript function to call to set the new color in the
		opener's form (optional, if not specified the color is just saved back to
		the original form)

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.util.Values"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
	String title = request.getParameter("title");
	String textarea = request.getParameter("textarea");
%>
<base:page type="popup" title="<%=title%>">
<base:head scripts="~select_color.js">
	<style>
	.colorchart
	{
		background:  #000000;
		border: 1px solid #000000;
		width: 100%; 
		height: 100%;
	}
	
	.colorchart td
	{
		border: 1px solid #000000;
		padding: 1px;
	}

	.colorchart td:hover, .colorchart td:focus
	{
		cursor: pointer;
		outline: 1px solid #FFFFFF;
		border: 2px solid #000000;
		padding: 0px;
	}
	</style>
</base:head>
<base:body>
	<h1><%=title%><base:help helpid="colorchart.selectcolor" /></h1>
	
	<div id="page-data" class="datacontainer"
		data-textarea="<%=textarea%>"
	></div>
	
	
	<form name="color">
	<div class="content filled">
		<div class="absolutefull" style="bottom: 2em;">
		<table class="colorchart">
		<%
		int red = 0;
		int green = 0;
		int blue = 0;
		int x = 0;
		int y = 0;
		while (red < 16 && green < 16 && blue < 16)
		{
			String r = Integer.toHexString(red).toUpperCase();
			String g = Integer.toHexString(green).toUpperCase();
			String b = Integer.toHexString(blue).toUpperCase();
			String full = r+r+g+g+b+b;
			if (x == 0)
			{
				%>
				<tr>
				<%
			}
			%>
			<td style="background: #<%=full%>;" 
				title="#<%=full%>"
				id="x<%=x%>y<%=y%>"
				data-red="<%=r+r%>" data-green="<%=g+g%>" data-blue="<%=b+b%>"
				data-x="<%=x%>" data-y="<%=y%>"
				tabindex="0"
				><div></div></td>
			<%
			x++;
			if (x == 18)
			{
				x = 0;
				y++;
				%>
				</tr>
				<%
			}
			red += 3;
			if (red == 18)
			{
				red = 0;
				green += 3;
				if (green == 9)
				{
					green = 0;
					blue += 3;
					if (blue == 18)
					{
						blue = 0;
						green = 9;
					}
				}
				else if (green == 18)
				{
					green = 9;
					blue += 3;
				}
			}
		}
		%>
		</table>
		</div>
		
		<div class="absolutefull" style="top: auto; bottom: 0px; height: 2em; border-top: 0px solid #000000;">
		<table style="margin: auto; height: 100%; border-spacing: 2px;" >
		<tr>
			<th>Red</th>
			<td><input class="text" type="text" name="red" value="" size="2" maxlength="2" title="Red color value in hexadecimal"></td>

			<th>Green</th>
			<td><input class="text" type="text" name="green" value="" size="2" maxlength="2" title="Green color value in hexadecimal"></td>

			<th>Blue</th>
			<td><input class="text" type="text" name="blue" value="" size="2" maxlength="2" title="Blue color value in hexadecimal"></td>
		</tr>
		</table>
		</div>

	</div>
	</form>
	
	<base:buttongroup subclass="dialogbuttons">
		<base:button id="btnSave" title="Ok" />
		<base:button id="close" title="Cancel" />
	</base:buttongroup>
	
</base:body>
</base:page>
